<?php

namespace STM\User;

use STM\Utils\Classes;
use STM\Competition\CompetitionSelection;
use \GetterOfTestingInstances;
use \Exception;
use STM\StmFactory;

/**
 * Test class for User.
 * Generated by PHPUnit on 2011-08-13 at 14:07:19.
 * @group user
 */
class UserTest extends \PHPUnit_Framework_TestCase {

    private $bad_values;
    private $all_users;
    private $admins;

    protected function setUp() {
        $this->bad_values = array(null, false, new Exception(), -20);
        $this->all_users = StmFactory::find()->User->findAll();
        $this->admins = StmFactory::find()->User->findByUserGroup(UserGroup::ADMIN);
    }

    protected function tearDown() {}

    public function testfindById() {
        foreach ($this->bad_values as $value) {
            $this->assertFalse(StmFactory::find()->User->findById($value));
        }
        foreach ($this->all_users as $user) {
            $this->assertFalse(StmFactory::find()->User->findById($user));
            parent::assertInstanceOf('\STM\User\User', StmFactory::find()->User->findById($user->getId()));
        }
    }

    public function testFind_by_name() {
        foreach ($this->bad_values as $value) {
            $this->assertFalse(StmFactory::find()->User->findByName($value));
        }
        foreach ($this->all_users as $user) {
            $name = $user->getUsername();
            parent::assertInstanceOf('\STM\User\User', StmFactory::find()->User->findByName($name));            
            $this->assertFalse(StmFactory::find()->User->findByName($user));
            if ($name != mb_strtolower($name, 'UTF-8')) {
                $this->assertFalse(StmFactory::find()->User->findByName(mb_strtolower($name, 'UTF-8')));
            }
            if ($name != mb_strtoupper($name, 'UTF-8')) {
                $this->assertFalse(StmFactory::find()->User->findByName(mb_strtoupper($name, 'UTF-8')));
            }
        }
    }

    public function testFind_all() {
        parent::assertTrue(is_array($this->all_users));
        foreach ($this->all_users as $user) {
            parent::assertInstanceOf('\STM\User\User', $user);
        }
    }

    public function testFind_number_of_users() {
        $this->assertEquals(count($this->all_users), StmFactory::count()->User->findAll());
        $this->assertEquals(count($this->admins), StmFactory::count()->User->findByUserGroup(UserGroup::ADMIN));
        $this->assertTrue(count($this->all_users) >= count($this->admins));
    }

    public function testauthenticateUser() {
        foreach ($this->all_users as $user) {
            foreach ($this->bad_values as $value) {
                $this->assertFalse(User::authenticateUser($user->getUsername(), $value));
            }
        }
        // trim is used in forms not directly in method -> false        
        // case sensitive
        // cannot test success because i dont know passwords
    }

    public function testCreate() {
        foreach ($this->bad_values as $value) {
            UserValidator::init();
            $this->assertFalse(User::create($value));
            UserValidator::init();
            $this->assertFalse(User::create(array($value)));
        }
        // rest in UserValidator
        // other fail: database connection fail or if somebody destroy function for generating passwords
    }

    public function testExists_user() {
        foreach ($this->bad_values as $value) {
            $this->assertFalse(User::exists($value));
        }
        foreach ($this->all_users as $user) {
            $name = $user->getUsername();
            $this->assertFalse(User::exists($user));
            $this->assertTrue(User::exists($name));
            $this->assertTrue(User::exists(mb_strtolower($name, 'UTF-8')));
            $this->assertTrue(User::exists(mb_strtoupper($name, 'UTF-8')));
            $this->assertFalse(User::exists('_*A*_' . $name));
            $this->assertFalse(User::exists('      ' . $name));
            $this->assertFalse(User::exists('      ' . $name . '        '));
        }
    }

    public function testDelete() {
        if (count($this->admins) == 1) {
            $user = array_shift($this->admins);
            $this->assertFalse($user->delete());
        }
    }

    public function testReset_password() {
        $this->markTestIncomplete('Only database fail or if somebody change function for generating passwords');
    }

    public function testChange_password() {
        foreach ($this->all_users as $user) {
            foreach ($this->bad_values as $value) {
                UserValidator::init();
                $this->assertFalse($user->updatePassword($value));
                UserValidator::init();
                $this->assertFalse($user->updatePassword(array($value, $value)));
                UserValidator::init();
                $this->assertFalse($user->updatePassword(array('new' => $value, 'old' => $value)));
            }
        }
    }

    public function testChange_email() {
        foreach ($this->all_users as $user) {
            foreach ($this->bad_values as $value) {
                UserValidator::init();
                $this->assertFalse($user->updateEmail($value));
            }
            UserValidator::init();
            $this->assertFalse($user->updateEmail($user->getEmail()));
            UserValidator::init();
            $this->assertFalse($user->updateEmail('test'));
            UserValidator::init();
            $this->assertFalse($user->updateEmail('test@test'));
            UserValidator::init();
            $this->assertFalse($user->updateEmail('@test.cz'));
        }
    }

    public function testChange_user_group() {
        foreach ($this->all_users as $user) {
            foreach ($this->bad_values as $value) {
                UserValidator::init();
                $this->assertFalse($user->updateUserGroup($value));
            }
            UserValidator::init();
            $this->assertFalse($user->updateUserGroup($user->getUserGroup()));
        }
    }

    public function testGet_id() {
        foreach ($this->all_users as $user) {
            $this->assertTrue(is_int($user->getId()));
        }
    }

    public function testGet_username() {
        foreach ($this->all_users as $user) {
            $this->assertTrue(is_string($user->getUsername()));
            $this->assertTrue(is_in_range(strlen($user->getUsername()), 2, 20));
        }
    }

    public function testGet_email() {
        foreach ($this->all_users as $user) {
            $email = $user->getEmail();
            if ($email) {
                $this->assertTrue(is_string($email));
            } else {
                $this->assertTrue(empty($email));
            }
        }
    }

    public function testGet_user_group() {
        foreach ($this->all_users as $user) {
            $this->assertTrue(Classes::isClassConstant('\STM\User\UserGroup', $user->getUserGroup()));
        }
        foreach ($this->admins as $user) {
            $this->assertTrue($user->getUserGroup() == UserGroup::ADMIN);
            $this->assertFalse($user->getUserGroup() == UserGroup::MANAGER);
        }
    }

    public function testTo_array() {
        foreach ($this->all_users as $user) {
            $this->assertArrayHasKey('name', $user->toArray());
            $this->assertArrayHasKey('email', $user->toArray());
            $this->assertArrayHasKey('user_group', $user->toArray());
        }
    }

    // COMPETITION MANAGER METHODS
    public function testAdd_managed_competition() {
        foreach ($this->all_users as $user) {
            // argument must be instanceof Competition
            foreach ($this->bad_values as $value) {
                $this->assertFalse($user->addManagedCompetition($value));
            }
            // only competition managers
            if ($user->getUserGroup() != UserGroup::COMPETITION_MANAGER) {
                $this->assertFalse($user->addManagedCompetition(StmFactory::find()->Competition->findById(1)));
            } else {
                // competitionmanager cannot add twice competition
                $competitionSelection = new CompetitionSelection();
                $competitionSelection->setCompetitionManager($user);
                $comp = StmFactory::find()->Competition->find($competitionSelection);
                if ($comp) {
                    foreach ($comp as $competition) {
                        $this->assertFalse($user->addManagedCompetition($competition));
                    }
                }
            }
        }
    }

    public function testDelete_managed_competition() {
        $competitions = GetterOfTestingInstances::find_competitions();
        foreach ($this->all_users as $user) {
            if ($user->getUserGroup() != UserGroup::COMPETITION_MANAGER) {
                $this->assertFalse($user->deleteManagedCompetition(StmFactory::find()->Competition->findById(1)));
            } else {
                foreach ($competitions as $competition) {
                    if (!$user->canUpdateCompetition($competition)) {
                        $this->assertFalse($user->deleteManagedCompetition($competition));
                    }
                }
            }
        }
    }

    public function testCan_update_competition() {
        foreach ($this->all_users as $user) {
            if ($user->getUserGroup() == UserGroup::COMPETITION_MANAGER) {
                $competitionSelection = new CompetitionSelection();
                $competitionSelection->setCompetitionManager($user);
                $comp = StmFactory::find()->Competition->find($competitionSelection);
                if ($comp) {
                    foreach ($comp as $competition) {
                        $this->assertTrue($user->canUpdateCompetition($competition));
                    }
                }             
            }
        }        
    }

}

function is_in_range($value, $min, $max) {
    return $value >= $min && $value <= $max;
}

?>
